//Make projectiles instantly collide with other players
lastProjectileTeam <- TF_TEAM_RED;
AddTimer(-1, 0, function ()
{
    lastProjectileTeam = lastProjectileTeam == TF_TEAM_RED ? TF_TEAM_BLUE : TF_TEAM_RED;
    for (local projectile; projectile = Entities.FindByClassname(projectile, "tf_projectile*");)
        projectile.SetTeam(redTeamOnly ? 3 : lastProjectileTeam);
});

OnGameEvent("OnTakeDamage", 0, function(player, params)
{
    //Caber Fix (didn't use to explode on teammates)
    if (GetPropInt(params.weapon, "m_iDetonated") == 0)
    {
        if (player.GetTeam() != params.attacker.GetTeam())
            return;
        local ogTeam = player.GetTeam();
        player.ForceChangeTeam(player.GetTeam() == TF_TEAM_RED ? TF_TEAM_BLUE : TF_TEAM_RED, false);
        RunWithDelay(-1, function(ogTeam) {
            self.ForceChangeTeam(ogTeam, false);
        }, ogTeam, player)
    }
});

AddTimer(-1, 0, function ()
{
    foreach(player in GetAllPlayers())
    {
        //Demoshield Charge Fix
        if (HasTarge(player))
        {
            local charge = GetPropFloat(player, "m_Shared.m_flChargeMeter");
            if ((GetPropInt(player, "m_nButtons") & IN_ATTACK2) && charge >= 100)
                player.AddCond(TF_COND_SHIELD_CHARGE);
            if (player.InCond(TF_COND_SHIELD_CHARGE))
            {
                if (charge <= 40)
                    player.AddCondEx(TF_COND_CRITBOOSTED_PUMPKIN, 0.75, player);
                else if (charge <= 75)
                    player.AddCondEx(TF_COND_OFFENSEBUFF, 0.75, player);
                if ((GetPropInt(player, "m_nButtons") & IN_ATTACK))
                    SetPropFloat(player, "m_Shared.m_flChargeMeter", 0);
            }
        }

        //Last Weapon Fix
        local weapon = player.GetActiveWeapon();
        local activeSlot = weapon ? weapon.GetSlot() : -1;
        for (local i = 0; i < 10; i++)
        {
            local weaponEnt = GetPropEntityArray(player, "m_hMyWeapons", i);
            if (weaponEnt && weaponEnt.GetSlot() != activeSlot)
                SetPropEntity(player, "m_hLastWeapon", weaponEnt)
        }
    }
});

//Cancel out Medic's self-heal
OnGameEvent("player_healed", function(params)
{
    if (params.patient == params.healer && params.amount < 10)
    {
        local player = GetPlayerFromUserID(params.patient);
        if (player && player.GetPlayerClass() == TF_CLASS_MEDIC)
            player.SetHealth(player.GetHealth() - params.amount);
    }
});